#include<iostream>
#include<vector>
using namespace std;
int N,Q,sum[100000],parent[100000];
bool a[100000];
void f(int m, int k){
    if(parent[m]!=0){
        sum[parent[m]]+=k;
        f(parent[m],k);
    }
}
int main(){
    int m,n,k;
    cin>>N;
    for(int i=0;i<N-1;i++){
        k=1;
        cin>>m>>n;
        parent[n]=m;
        if(!a[m]){
            a[m]=true;
            sum[m]+=sum[n];
            k=sum[n]+1;
        }
        sum[m]++;
        f(m,k);
    }
    cin>>Q;
    for(int i=0;i<Q;i++){
        cin>>m;
        cout<<sum[m]<<endl;
    }
return 0;
}
